#ifndef T1_AREA_H
#define T1_AREA_H

#include <Piece.h>
#include <Area.h>
#include <T2n_Area.h>
#include <T0_Area.h>

#define SECOND_COLUMN 1
#define T1_ALL_COLUMNS 2

class T1_Area : public T2n_Area {

  public:
    
    /*
    * Constructor with all information.
    */
    T1_Area(void * register_info_, Area * left_, Area * right_);

    /*
    * This method allocate the given piece in the specified column.
    * Returns true if the piece was allocated. false otherwise.    
    */
    virtual bool allocate(Piece * piece, unsigned column);

    /*
    * Gets the top piece of the specified column.
    */
    Piece * get_up_piece(unsigned column);

    /*
    * Gets the bottom piece of the specified column.
    */
    Piece * get_down_piece(unsigned column);

    /*
    * Returns true if the the area has a free space in the specified coordinate,
    * false otherwise.
    */
    bool is_free(unsigned column, unsigned row);
    
};

#endif
