#include <Piece.h>
#include <Types.h>

#include <string>

using namespace std;

/*
* The constructor
*/
Piece::Piece(void * _var_info,PieceType _type,unsigned _size,unsigned _priority):
    var_info(_var_info),type(_type),size(_size),priority(_priority){}
    
/*
* Returns the variable information stored in this piece.
*/
void * Piece::get_var_info(){
    return var_info;
}
    
/*
* Returns the piece type of this piece.
*/
PieceType Piece::get_type(){
    return type;
}
    
/*
* Returns the size of this piece.
*/
unsigned Piece::get_size(){
    return size;
}
    
/*
* Returns the priority of this piece.
*/
unsigned Piece::get_priority(){
    return priority;
}

string Piece::to_string(DATA_STRING var_info_to_string){
    string rep = "";
    switch(type) {
        case X :
            rep += "X";
            break;
        case Y :
            rep += "Y";
            break;
        case Z :
            rep += "Z";
    }
    rep += "(" + var_info_to_string(var_info) + ")";
    return rep;
}
