#include <Solver.h>
#include <preferences.h>
#include <PieceType.h>
#include <spans.h>

/*
* The constructor.
*/
Solver::Solver(Board * board_, PieceFactory * pieces_)
    :board(board_),pieces(pieces_){}

/*
* Here we do not have anything to do here
*/
Solver::~Solver(){}

/*
* This pad method just add the necesary x and y pieces to make
* this puzzle solvable.
* If there are more pieces then the padding is empty.
* The new pieces are stored in the DEFAULT_PREFERENCE
*/
void Solver::pad(){
    int needed = board->get_free_x_number() - pieces->get_x_to_fill_number();
    for(;needed>0;needed--){
        pieces->new_piece(0,X,0,0,DEFAULT_PREFERENCE,SPAN_1);
    }
    needed = board->get_free_z_number() - pieces->get_z_to_fill_number();
    for(;needed>0;needed--){
        pieces->new_piece(0,Z,0,0,DEFAULT_PREFERENCE,SPAN_1);
    }
}
