#include <T1_Solver.h>
#include <T1_patterns.h>
#include <T1_Area.h>
#include <spans.h>

/*
* The constructor.
*/
T1_Solver::T1_Solver(Board * board_, PieceFactory * pieces_):Solver(board_,pieces_){}

bool T1_Solver::solve(){
    /*
    * First We have to padd.
    */
    pad();
    /*
    * The needed iterators.
    */
    std::vector<Area *>::iterator it;
    std::vector<Area *>::iterator end = board->get_areas_end();
    //The first rule 0111
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 0111 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_0111 && 
            pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
            area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
        }
    }
    //The second rule
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 1101 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_1101 && 
            pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
            area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
        }
    }
    //The third rule 
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 1110 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_1110 && 
            pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
            area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
        }
    }
    //The 4th rule 
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 1011 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_1011 && 
            pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
            area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
        }
    }
    //The 5th rule 
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 0110 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_0110 && 
            pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
            pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 ){
            area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
            area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
        }
    }
    //The 6th rule 
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 1001 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_1001 && 
            pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
            pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 ){
            area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
        }
    }
    //The 7th rule
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 0101 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_0101 ){
            if(pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
            }else if (pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }
        }
    }
    //The 8th rule
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 1010 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_1010 ){
            if(pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1){
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
            }else if (pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2){
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }
        }
    }
    //The 9th rule
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 0011 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_0011 ){
            if(pieces->get_available_number(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
                area->allocate(pieces->get_piece(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
            }
        }
    }
    //The 10th rule
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 1100 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_1100 ){
            if(pieces->get_available_number(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
                area->allocate(pieces->get_piece(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }
        }
    }
    //The 11th rule
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 0001 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_0001 ){
            if( pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1 &&
                pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 ){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                        pieces->get_available_number(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
                area->allocate(pieces->get_piece(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
            }
        }
    }
    //The 12th rule
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 0001 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_0100 ){
            if( pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1 &&
                pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 ){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                        pieces->get_available_number(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }
        }
    }
    //The 13th rule.
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 0010 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_0010 ){
            if( pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1 ){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
            }else if (  pieces->get_available_number(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
                area->allocate(pieces->get_piece(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }
        }
    }
    //The 14th rule.
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 1000 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_1000 ){
            if( pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1 ){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
            }else if (  pieces->get_available_number(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1){
                area->allocate(pieces->get_piece(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }
        }
    }
    //The 15th rule.
    for(it = board->get_areas_begin();it != end;it++){
        //Check if the area has the 1000 pattern
        Area * area = *it;
        if( area -> get_pattern() == T1_0000 ){
            if( pieces->get_available_number(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1 ){
                area->allocate(pieces->get_piece(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
            } else if( pieces->get_available_number(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2 ){
                area->allocate(pieces->get_piece(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }else if ( pieces->get_available_number(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                        pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 1 ){
                area->allocate(pieces->get_piece(Y,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1 ){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2 ){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2) >= 1 ){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_2),FIRST_COLUMN);
            }else if (  pieces->get_available_number(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2 &&
                        pieces->get_available_number(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1) >= 2 ){
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(X,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),FIRST_COLUMN);
                area->allocate(pieces->get_piece(Z,
                area->get_preferences_begin(),
                area->get_preferences_end(),
                SPAN_1),SECOND_COLUMN);
            }
        }
    }
}
