#ifndef _PIECE_H
#define _PIECE_H

#include <PieceType.h>
#include <Types.h>

#include <string>

/*Piece.h:48: error: expected unqualified-id at end of input

* This class represents one puzzle piece.
* It represents "variable", is of type "type" and has size "size".
*/
class Piece {
  public:
    
    /*
    * The constructor
    */
    Piece(void * _var_info,PieceType _type,unsigned _size,unsigned _priority);
    
    /*
    * Returns the variable information stored in this piece.
    */
    void * get_var_info();
    
    /*
    * Returns the piece type of this piece.
    */
    PieceType get_type();
    
    /*
    * Returns the size of this piece.
    */
    unsigned get_size();
    
    /*
    * Returns the priority of this piece.
    */
    unsigned get_priority();
    
    /*
    * Returns a string representaion of this object.
    * It gets a pointer to a method, wich is the method to show
    * a readable string representation of the var_info.
    */
    virtual std::string to_string(DATA_STRING var_info_to_string);
    
  protected:
    /*
    * Some information abaut the variable. Since any simple identifier
    * to any useful data.
    */
    void * var_info;
    /*
    * The piece type. 
    */
    PieceType type;
    /* 
    * The piece size, it depends directly of the aliassing.
    */
    unsigned size;
    /*
    * The priority of this piece.
    */
    unsigned priority;
};

#endif
