#ifndef _SOLVER_H
#define _SOLVER_H

#include <Board.h>
#include <PieceFactory.h>
#include <T0_patterns.h>

/*
* This class abstract a solver.
* It has a board wich will be solved and some pieces 
* stored in a PieceFacory.
*/
class Solver {
  public:
  
    /*
    * The constructor.
    */
    Solver(Board * board_, PieceFactory * pieces_);
    
    /*
    * The virtual destructor.
    */
    virtual ~Solver();
    
    /*
    * This method padds the the puzzle.
    */
    virtual void pad();
    
    /*
    * This method solves the puzzle represented with this board.
    * returns true if the puzzle is solvable and false otherwise.
    */
    virtual bool solve() = 0;
    
  protected:
    /*
    * The board to be solved.
    */
    Board * board;
    /*
    * The pieces to solve the puzzle.
    */
    PieceFactory * pieces;
};

#endif

