#include <Area.h>
#include <cmath>
#include <string>

using namespace std;

/*
* This class is the base class to represent the 2^n (n >= 1) type
* areas. Now the only type of this areas is the type 1 area, but 
* later more complex algoriths will come.
* (The algorithm for type 2 areas is being developed.)
*/

class T2n_Area : public Area { 
  public:
        
    /*
    * The constructor.
    */
    T2n_Area(
    unsigned type_,
    void * register_info_,
    Area * left_,
    Area * right_);
    
    /*
    * Removes all the pieces allocated in this area.
    */
    void remove_pieces();
    
    
    /*
    * This method returns the pattern of this Area.
    * This method requires to know the type puzzle, and to do that 
    * eficently and to do not require more changes, it uses the type 
    * member of the area class.
    */
    unsigned get_pattern();
    
    /*
    * Returns a string representation of this object. 
    * This method is virtual in order to be able to choose another 
    * string representation, but it can be used anyway.
    */
    virtual string to_string(
    DATA_STRING var_info_to_string,
    DATA_STRING register_info_to_string,
    bool show_register_info);
    
    /*
    * Returns the number of free x spots.
    */
    unsigned get_free_x_number();
    
    /*
    * Returns the number of free z spots.
    */
    unsigned get_free_z_number();
    
  protected:
    /*
    * The left type 2^(n-1) Area.
    */
    Area * left;
    /*
    * The right type 2^(n-1) Area.
    */
    Area * right;

};
