#include <Board.h>
#include <T0_Area.h>
#include <preferences.h>

#include <string>

#include <T0_X86_Board.h>

using namespace std;

/*
* The constructor will make the proper inicialization of the variables.
* There should be stored
*/
T0_X86_Board::T0_X86_Board(){
    //The type 0 areas
    Area * area;
    BP = new string("BP");
    //The BP register Base pointer (Maybe it should not be here)
    area = new T0_Area(BP);
    //Insert the preferences of this area.
    area->add_preference(DEFAULT_PREFERENCE);
    //Push on the areas
    areas.push_back(area);

    SI = new string("SI");
    //The SI register. Used for source index in streams.
    area = new T0_Area(SI);
    //Insert the preferences of this area.
    area->add_preference(DEFAULT_PREFERENCE);
    //Push on the areas
    areas.push_back(area);
    
    DI = new string("DI");
    //The DI register. Used for destination index in streams.
    area = new T0_Area(DI);
    //Insert the preferences of this area.
    area->add_preference(DEFAULT_PREFERENCE);
    //Push on the areas
    areas.push_back(area);
    
    SP = new string("SP");
    //The stack pointer (Maybe it should not be here)
    area = new T0_Area(SP);
    //Insert the preferences of this area.
    area->add_preference(DEFAULT_PREFERENCE);
    //Push on the areas
    areas.push_back(area);
}

T0_X86_Board::~T0_X86_Board(){
    delete BP;
    delete SI;
    delete DI;
    delete SP;
}

