#include <Board.h>
#include <T1_Area.h>
#include <T1_Area.h>
#include <preferences.h>

#include <T1_X86_Board.h>

/*
* The A register family.
*/
string AX("AX");
string AH("AH");
string AL("AL");

/*
* The B register family.
*/
string BX("BX");
string BH("BH");
string BL("BL");

/*
* The C register family.
*/
string CX("CX");
string CH("CH");
string CL("CL");

/*
* The D register family.
*/
string DX("DX");
string DH("DH");
string DL("DL");

/*
* The constructor will make the proper inicialization of the variables.
* There should be stored
*/
T1_X86_Board::T1_X86_Board():
    T0_AL(&AL),
    T0_AH(&AH),
    T0_BL(&BL),
    T0_BH(&BH),
    T0_CL(&CL),
    T0_CH(&CH),
    T0_DL(&DL),
    T0_DH(&DH)
    {
    //The type 1 areas
    Area * area;
    
    //The AX register.
    area = new T1_Area(&AX,&T0_AL,&T0_AH);
    //Insert the preferences of this area.
    area->add_preference(DEFAULT_PREFERENCE);
    //Push on the areas
    areas.push_back(area);
    
    //The BX register.
    area = new T1_Area(&BX,&T0_BL,&T0_BH);
    //Insert the preferences of this area.
    area->add_preference(DEFAULT_PREFERENCE);
    //Push on the areas
    areas.push_back(area);
    
    //The CX register.
    area = new T1_Area(&CX,&T0_CL,&T0_CH);
    //Insert the preferences of this area.
    area->add_preference(DEFAULT_PREFERENCE);
    //Push on the areas
    areas.push_back(area);
    
    //The DX register.
    area = new T1_Area(&DX,&T0_DL,&T0_DH);
    //Insert the preferences of this area.
    area->add_preference(DEFAULT_PREFERENCE);
    //Push on the areas
    areas.push_back(area);
}
